﻿'Prologue

Public Class frmDragAndDropDemo

    Private Sub lstFruits_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstFruits.DragDrop
        'Drops object and removes original

        lstFruits.Items.Add(e.Data.GetData(DataFormats.Text))
        lstVegetables.Items.Remove(lstVegetables.SelectedItem)

        'Checks to see how many are in the right place
        CountNumRight()

    End Sub

    Private Sub lstFruits_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstFruits.DragEnter
        'Checks to see if item can be dropped into this location
        If e.Data.GetDataPresent(DataFormats.Text) Then
            e.Effect = DragDropEffects.Move
        Else
            e.Effect = DragDropEffects.None
        End If

    End Sub

    Private Sub lstVegetables_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstVegetables.DragDrop
        'Drops object and removes original
        lstVegetables.Items.Add(e.Data.GetData(DataFormats.Text))
        lstFruits.Items.Remove(lstFruits.SelectedItem)

        'Checks to see how many are in the right place
        CountNumRight()

    End Sub

    Private Sub lstVegetables_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstVegetables.DragEnter
        'Checks to see if item can be dropped into this location
        If e.Data.GetDataPresent(DataFormats.Text) Then
            e.Effect = DragDropEffects.Move
        Else
            e.Effect = DragDropEffects.None
        End If
    End Sub

    Private Sub lstVegetables_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lstVegetables.MouseDown
        'Grabs item so it can be moved
        lstVegetables.DoDragDrop(lstVegetables.SelectedItem, DragDropEffects.Move)

    End Sub


    Private Sub lstFruits_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lstFruits.MouseDown
        'Grabs item so it can be moved
        lstFruits.DoDragDrop(lstFruits.SelectedItem, DragDropEffects.Move)

    End Sub

    Private Sub CountNumRight()
        'Counts the number of correct items in each ListBox and displays results
        Dim bytNumFruits As Byte
        Dim bytNumVeges As Byte
        Dim i As Integer

        'Counts number of correct vegetables
        For i = 0 To lstVegetables.Items.Count - 1
            Select Case lstVegetables.Items.Item(i)
                Case Is = "Beans", "Carrots", "Peas", "Radishes", "Lettuce", "Corn"
                    bytNumVeges += 1
            End Select
        Next i

        'Counts number of correct fruits
        For i = 0 To lstFruits.Items.Count - 1
            Select Case lstFruits.Items.Item(i)
                Case Is = "Oranges", "Apples", "Bananas", "Grapes", "Cherries", "Pears"
                    bytNumFruits += 1
            End Select
        Next i

        'If all items are in the right place, disables drag and drop
        If bytNumFruits = 6 And bytNumVeges = 6 Then
            lblDone.Text = "You Got It!"
            lstVegetables.AllowDrop = False
            lstFruits.AllowDrop = False

        End If

        'Displays the number of items in correct location
        lblFruit.Text = bytNumFruits.ToString
        lblVegetables.Text = bytNumVeges.ToString

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        'Ends the program
        End

    End Sub
End Class
