﻿'Prologue

Public Class frmDiceDrag
    Dim mblnpic1 As Boolean
    Dim mblnpic2 As Boolean
    Dim mblnpic3 As Boolean
    Dim mblnpic4 As Boolean
    Dim mblnpic5 As Boolean
    Dim mblnpic6 As Boolean
    Dim mbytNum As Byte
    Dim mbytTotal As Byte
    Dim mbytNumDice As Byte

    Private Sub pic1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pic1.MouseDown
        'Sets Boolean to True so die can be dropped
        'Others controls work the same way for their die
        mblnpic1 = True
        pic1.DoDragDrop(pic1.Image, DragDropEffects.Move)
    End Sub

    Private Sub pic2_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pic2.MouseDown
        mblnpic2 = True
        pic2.DoDragDrop(pic2.Image, DragDropEffects.Move)
    End Sub

    Private Sub pic3_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pic3.MouseDown
        mblnpic3 = True
        pic3.DoDragDrop(pic3.Image, DragDropEffects.Move)

    End Sub

    Private Sub pic4_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pic4.MouseDown
        mblnpic4 = True
        pic4.DoDragDrop(pic4.Image, DragDropEffects.Move)
    End Sub


    Private Sub pic5_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pic5.MouseDown
        mblnpic5 = True
        pic5.DoDragDrop(pic5.Image, DragDropEffects.Move)
    End Sub


    Private Sub pic6_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pic6.MouseDown
        mblnpic6 = True
        pic6.DoDragDrop(pic6.Image, DragDropEffects.Move)
    End Sub


    Private Sub pnlTarget_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles pnlTarget.DragDrop
        'Checks to see if the die should be dropped and drops it in the right place as needed
        If mblnpic1 Then picDrop1.Image = e.Data.GetData(DataFormats.Bitmap)
        If mblnpic2 Then picDrop2.Image = e.Data.GetData(DataFormats.Bitmap)
        If mblnpic3 Then picDrop3.Image = e.Data.GetData(DataFormats.Bitmap)
        If mblnpic4 Then picDrop4.Image = e.Data.GetData(DataFormats.Bitmap)
        If mblnpic5 Then picDrop5.Image = e.Data.GetData(DataFormats.Bitmap)
        If mblnpic6 Then picDrop6.Image = e.Data.GetData(DataFormats.Bitmap)

        CheckGraphics()

    End Sub

    Private Sub pnlTarget_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles pnlTarget.DragEnter
        'Set use panel to accept dice

        If e.Data.GetDataPresent(DataFormats.Bitmap) Then
            e.Effect = DragDropEffects.Move
        Else
            e.Effect = DragDropEffects.None
        End If

    End Sub

    Private Sub CheckGraphics()
        'Hide die once dropped
        'Disables die
        'Adds die value to total

        'Adds one to number of dice used
        mbytNumDice += 1

        If mblnpic1 = True Then
            pic1.Visible = False
            mblnpic1 = False
            mbytTotal += 1
        End If
        If mblnpic2 = True Then
            pic2.Visible = False
            mblnpic2 = False
            mbytTotal += 2
        End If
        If mblnpic3 = True Then
            pic3.Visible = False
            mblnpic3 = False
            mbytTotal += 3
        End If
        If mblnpic4 = True Then
            pic4.Visible = False
            mblnpic4 = False
            mbytTotal += 4
        End If
        If mblnpic5 = True Then
            pic5.Visible = False
            mblnpic5 = False
            mbytTotal += 5
        End If
        If mblnpic6 = True Then
            pic6.Visible = False
            mblnpic6 = False
            mbytTotal += 6
        End If

        'Checks to see if over the total or over the three dice limit
        'Displays over and enables New button
        If mbytTotal > mbytNum Or mbytNumDice > 3 Then
            lblNum.Text = "Over"
            btnNew.Enabled = True

        End If

        'Check to see if total is right and three dice were used
        'Reset game
        If mbytTotal = mbytNum And mbytNumDice = 3 Then
            btnNew.Enabled = True
            btnRestart.Enabled = False
            btnNew.Focus()

            lblNum.Text = "Got it!"

        End If

    End Sub

    Private Sub btnNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNew.Click
        'Sets up the form and gets a new number
        pnlTarget.AllowDrop = True

        Reset()

        mbytNum = Int(Rnd() * 10 + 6)
        lblNum.Text = mbytNum.ToString

        btnNew.Enabled = False
        btnRestart.Enabled = True
        rtbDirections.Visible = False

    End Sub

    Private Sub Reset()
        'Resets pictures, Booleans and totals for new game
        'Called by btnNew and btnRestart
        pic1.Visible = True
        picDrop1.Image = Nothing
        pic2.Visible = True
        picDrop2.Image = Nothing
        pic3.Visible = True
        picDrop3.Image = Nothing
        pic4.Visible = True
        picDrop4.Image = Nothing
        pic5.Visible = True
        picDrop5.Image = Nothing
        pic6.Visible = True
        picDrop6.Image = Nothing
        mblnpic1 = False
        mblnpic2 = False
        mblnpic3 = False
        mblnpic4 = False
        mblnpic5 = False
        mblnpic6 = False

        mbytTotal = 0
        mbytNumDice = 0

    End Sub

    Private Sub frmDragDice_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Randomize()

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        End

    End Sub

    Private Sub btnRestart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRestart.Click
        'Resets game with same number for another try
        'Only works when they go over or use four dice
        Reset()
        lblNum.Text = mbytNum.ToString

    End Sub

    Private Sub rtbDirections_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles rtbDirections.Click
        'Hides directions when clicked
        rtbDirections.Visible = False

    End Sub

    Private Sub tmrDirections_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrDirections.Tick
        'Hides directions automatically
        rtbDirections.Visible = False
        tmrDirections.Enabled = False

    End Sub
End Class