﻿Module Module1
    'Shift differential rates
    Private Const sng2ndShiftDiff As Single = 0.05
    Private Const sng3rdShiftDiff As Single = 0.1

    Private Function CalcRegularPay(ByVal sngHours As Single, ByVal decPayRate As Decimal) As Decimal
        'Checks for overtime and calculates pay
        If sngHours > 40 Then
            Return ((sngHours - 40) * decPayRate * 1.5) + (decPayRate * 40)
        Else
            Return sngHours * decPayRate
        End If

    End Function

    Private Function CalcWages(ByVal sngHours As Single, ByVal decPayRate As Decimal) As Decimal
        'Calculates first shift pay
        Return CalcRegularPay(sngHours, decPayRate)

    End Function

    Private Function CalcWages(ByVal sngHours As Single, ByVal decPayRate As Decimal, ByVal sngShift As Single) As Decimal
        'Calculates shift differentials pay
        Dim decRegularPay As Decimal

        decRegularPay = CalcRegularPay(sngHours, decPayRate)
        If sngShift = 2 Then
            Return decRegularPay + (decRegularPay * sng2ndShiftDiff)
        End If
        If sngShift = 3 Then
            Return decRegularPay + (decRegularPay * sng3rdShiftDiff)
        End If

    End Function

End Module
